Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.Designer.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.Designer.cs	(revision 16897)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.Designer.cs	(revision 16898)
@@ -45,5 +45,4 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      this.definitionLabel = new System.Windows.Forms.Label();
       this.lowerboundLabel = new System.Windows.Forms.Label();
       this.upperboundLabel = new System.Windows.Forms.Label();
@@ -52,5 +51,4 @@
       this.variableLabel = new System.Windows.Forms.Label();
       this.numberderivationLabel = new System.Windows.Forms.Label();
-      this.definitionInput = new System.Windows.Forms.TextBox();
       this.upperboundInput = new System.Windows.Forms.TextBox();
       this.lowerboundInput = new System.Windows.Forms.TextBox();
@@ -65,21 +63,13 @@
       this.incllowerboundInput = new System.Windows.Forms.CheckBox();
       this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      this.enabledLabel = new System.Windows.Forms.Label();
       this.groupBox1.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
       // 
-      // definitionLabel
-      // 
-      this.definitionLabel.AutoSize = true;
-      this.definitionLabel.Location = new System.Drawing.Point(11, 72);
-      this.definitionLabel.Name = "definitionLabel";
-      this.definitionLabel.Size = new System.Drawing.Size(54, 13);
-      this.definitionLabel.TabIndex = 1;
-      this.definitionLabel.Text = "Definition:";
-      // 
       // lowerboundLabel
       // 
       this.lowerboundLabel.AutoSize = true;
-      this.lowerboundLabel.Location = new System.Drawing.Point(11, 98);
+      this.lowerboundLabel.Location = new System.Drawing.Point(8, 101);
       this.lowerboundLabel.Name = "lowerboundLabel";
       this.lowerboundLabel.Size = new System.Drawing.Size(69, 13);
@@ -90,5 +80,5 @@
       // 
       this.upperboundLabel.AutoSize = true;
-      this.upperboundLabel.Location = new System.Drawing.Point(11, 123);
+      this.upperboundLabel.Location = new System.Drawing.Point(8, 126);
       this.upperboundLabel.Name = "upperboundLabel";
       this.upperboundLabel.Size = new System.Drawing.Size(69, 13);
@@ -99,5 +89,5 @@
       // 
       this.incllowerboundLabel.AutoSize = true;
-      this.incllowerboundLabel.Location = new System.Drawing.Point(11, 149);
+      this.incllowerboundLabel.Location = new System.Drawing.Point(8, 153);
       this.incllowerboundLabel.Name = "incllowerboundLabel";
       this.incllowerboundLabel.Size = new System.Drawing.Size(92, 13);
@@ -108,5 +98,5 @@
       // 
       this.inclupperboundLabel.AutoSize = true;
-      this.inclupperboundLabel.Location = new System.Drawing.Point(11, 174);
+      this.inclupperboundLabel.Location = new System.Drawing.Point(8, 178);
       this.inclupperboundLabel.Name = "inclupperboundLabel";
       this.inclupperboundLabel.Size = new System.Drawing.Size(92, 13);
@@ -117,5 +107,5 @@
       // 
       this.variableLabel.AutoSize = true;
-      this.variableLabel.Location = new System.Drawing.Point(11, 199);
+      this.variableLabel.Location = new System.Drawing.Point(8, 47);
       this.variableLabel.Name = "variableLabel";
       this.variableLabel.Size = new System.Drawing.Size(48, 13);
@@ -126,5 +116,5 @@
       // 
       this.numberderivationLabel.AutoSize = true;
-      this.numberderivationLabel.Location = new System.Drawing.Point(11, 225);
+      this.numberderivationLabel.Location = new System.Drawing.Point(8, 74);
       this.numberderivationLabel.Name = "numberderivationLabel";
       this.numberderivationLabel.Size = new System.Drawing.Size(65, 13);
@@ -132,18 +122,9 @@
       this.numberderivationLabel.Text = "#Derivation:";
       // 
-      // definitionInput
-      // 
-      this.definitionInput.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.definitionInput.Location = new System.Drawing.Point(111, 69);
-      this.definitionInput.Name = "definitionInput";
-      this.definitionInput.Size = new System.Drawing.Size(473, 20);
-      this.definitionInput.TabIndex = 9;
-      // 
       // upperboundInput
       // 
       this.upperboundInput.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.upperboundInput.Location = new System.Drawing.Point(111, 120);
+      this.upperboundInput.Location = new System.Drawing.Point(108, 123);
       this.upperboundInput.Name = "upperboundInput";
       this.upperboundInput.Size = new System.Drawing.Size(473, 20);
@@ -156,5 +137,5 @@
       this.lowerboundInput.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.lowerboundInput.Location = new System.Drawing.Point(111, 95);
+      this.lowerboundInput.Location = new System.Drawing.Point(108, 98);
       this.lowerboundInput.Name = "lowerboundInput";
       this.lowerboundInput.Size = new System.Drawing.Size(473, 20);
@@ -167,5 +148,5 @@
       this.variableInput.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.variableInput.Location = new System.Drawing.Point(111, 196);
+      this.variableInput.Location = new System.Drawing.Point(108, 44);
       this.variableInput.Name = "variableInput";
       this.variableInput.Size = new System.Drawing.Size(473, 20);
@@ -174,4 +155,5 @@
       // groupBox1
       // 
+      this.groupBox1.Controls.Add(this.enabledLabel);
       this.groupBox1.Controls.Add(this.label1);
       this.groupBox1.Controls.Add(this.numberderivationInput);
@@ -184,5 +166,4 @@
       this.groupBox1.Controls.Add(this.lowerboundInput);
       this.groupBox1.Controls.Add(this.upperboundInput);
-      this.groupBox1.Controls.Add(this.definitionInput);
       this.groupBox1.Controls.Add(this.numberderivationLabel);
       this.groupBox1.Controls.Add(this.variableLabel);
@@ -191,5 +172,4 @@
       this.groupBox1.Controls.Add(this.upperboundLabel);
       this.groupBox1.Controls.Add(this.lowerboundLabel);
-      this.groupBox1.Controls.Add(this.definitionLabel);
       this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
       this.groupBox1.Location = new System.Drawing.Point(0, 0);
@@ -203,5 +183,5 @@
       // 
       this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(11, 22);
+      this.label1.Location = new System.Drawing.Point(11, -105);
       this.label1.Name = "label1";
       this.label1.Size = new System.Drawing.Size(49, 13);
@@ -214,7 +194,7 @@
             | System.Windows.Forms.AnchorStyles.Right)));
       this.numberderivationInput.FormattingEnabled = true;
-      this.numberderivationInput.Location = new System.Drawing.Point(111, 225);
+      this.numberderivationInput.Location = new System.Drawing.Point(108, 71);
       this.numberderivationInput.Name = "numberderivationInput";
-      this.numberderivationInput.Size = new System.Drawing.Size(470, 21);
+      this.numberderivationInput.Size = new System.Drawing.Size(473, 21);
       this.numberderivationInput.TabIndex = 27;
       this.numberderivationInput.SelectedIndexChanged += new System.EventHandler(this.numberderivationInput_SelectedIndexChanged);
@@ -223,5 +203,5 @@
       // 
       this.ischeckedCheckBox.AutoSize = true;
-      this.ischeckedCheckBox.Location = new System.Drawing.Point(111, 21);
+      this.ischeckedCheckBox.Location = new System.Drawing.Point(108, 200);
       this.ischeckedCheckBox.Name = "ischeckedCheckBox";
       this.ischeckedCheckBox.Size = new System.Drawing.Size(15, 14);
@@ -234,5 +214,5 @@
       this.expressionInput.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.expressionInput.Location = new System.Drawing.Point(111, 44);
+      this.expressionInput.Location = new System.Drawing.Point(108, 19);
       this.expressionInput.Name = "expressionInput";
       this.expressionInput.Size = new System.Drawing.Size(473, 20);
@@ -242,5 +222,5 @@
       // 
       this.expressionLabel.AutoSize = true;
-      this.expressionLabel.Location = new System.Drawing.Point(11, 47);
+      this.expressionLabel.Location = new System.Drawing.Point(8, 22);
       this.expressionLabel.Name = "expressionLabel";
       this.expressionLabel.Size = new System.Drawing.Size(61, 13);
@@ -251,5 +231,5 @@
       // 
       this.inclupperboundInput.AutoSize = true;
-      this.inclupperboundInput.Location = new System.Drawing.Point(111, 173);
+      this.inclupperboundInput.Location = new System.Drawing.Point(108, 177);
       this.inclupperboundInput.Name = "inclupperboundInput";
       this.inclupperboundInput.Size = new System.Drawing.Size(15, 14);
@@ -261,5 +241,5 @@
       // 
       this.incllowerboundInput.AutoSize = true;
-      this.incllowerboundInput.Location = new System.Drawing.Point(111, 149);
+      this.incllowerboundInput.Location = new System.Drawing.Point(108, 153);
       this.incllowerboundInput.Name = "incllowerboundInput";
       this.incllowerboundInput.Size = new System.Drawing.Size(15, 14);
@@ -272,4 +252,13 @@
       this.errorProvider.ContainerControl = this;
       this.errorProvider.RightToLeft = true;
+      // 
+      // enabledLabel
+      // 
+      this.enabledLabel.AutoSize = true;
+      this.enabledLabel.Location = new System.Drawing.Point(8, 200);
+      this.enabledLabel.Name = "enabledLabel";
+      this.enabledLabel.Size = new System.Drawing.Size(49, 13);
+      this.enabledLabel.TabIndex = 29;
+      this.enabledLabel.Text = "Enabled:";
       // 
       // IntervalConstraintView
@@ -287,5 +276,4 @@
 
     #endregion
-    private System.Windows.Forms.Label definitionLabel;
     private System.Windows.Forms.Label lowerboundLabel;
     private System.Windows.Forms.Label upperboundLabel;
@@ -294,5 +282,4 @@
     private System.Windows.Forms.Label variableLabel;
     private System.Windows.Forms.Label numberderivationLabel;
-    private System.Windows.Forms.TextBox definitionInput;
     private System.Windows.Forms.TextBox upperboundInput;
     private System.Windows.Forms.TextBox lowerboundInput;
@@ -307,4 +294,5 @@
     private System.Windows.Forms.ComboBox numberderivationInput;
     private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.Label enabledLabel;
   }
 }
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.cs	(revision 16897)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalConstraintView.cs	(revision 16898)
@@ -39,5 +39,4 @@
       int [] items = {1, 2, 3};
       expressionInput.ReadOnly = true;
-      definitionInput.ReadOnly = true;
       numberderivationInput.DataSource = items;
     }
@@ -63,6 +62,4 @@
       upperboundInput.Enabled = Content != null && !Locked && !ReadOnly;
       expressionInput.Enabled = Content != null && !Locked && !ReadOnly;
-      definitionInput.Enabled = Content != null && !Locked && !ReadOnly;
-      definitionInput.ReadOnly = true;
       expressionInput.ReadOnly = true;
       variableInput.ReadOnly = true;
@@ -105,5 +102,4 @@
 
       expressionInput.Text = Content.Expression;
-      definitionInput.Text = Content.Definition;
       lowerboundInput.Text = Content.Interval.LowerBound.ToString();
       upperboundInput.Text = Content.Interval.UpperBound.ToString();
@@ -112,6 +108,7 @@
       variableInput.Text = Content.Variable;
       if (!Content.IsDerivation) {
-        numberderivationInput.Visible = false;
-        numberderivationLabel.Visible = false;
+        numberderivationInput.Enabled = false;
+        numberderivationInput.SelectedItem = null;
+        numberderivationInput.SelectedText = "0";
       } else {
         numberderivationLabel.Visible = true;
@@ -190,10 +187,14 @@
 
     private void numberderivationInput_SelectedIndexChanged(object sender, EventArgs e) {
+      if (numberderivationInput.SelectedItem == null) { 
+        Content.NumberOfDerivation = 0;
+        return;
+      }
       if ((int)numberderivationInput.SelectedItem == 1)
-        Content.numberOfDerivation = 1;
+        Content.NumberOfDerivation = 1;
       else if ((int)numberderivationInput.SelectedItem == 2)
-        Content.numberOfDerivation = 2;
+        Content.NumberOfDerivation = 2;
       else if ((int)numberderivationInput.SelectedItem == 3)
-        Content.numberOfDerivation = 3;
+        Content.NumberOfDerivation = 3;
     }
 
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs	(revision 16897)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraint.cs	(revision 16898)
@@ -62,5 +62,5 @@
     }
 
-    public int numberOfDerivation;
+    private int numberOfDerivation;
     [Storable]
     public int NumberOfDerivation {
@@ -69,5 +69,5 @@
         if (value < 0 || value > 3)
           throw new ArgumentException("Number of derivation has to be between 0 - 3.");
-        if (value != numberOfDerivation) {
+        if (numberOfDerivation != value) {
           numberOfDerivation = value;
           UpdateExpression();