Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs	(revision 16903)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs	(revision 16904)
@@ -98,6 +98,6 @@
     }
 
-    public NamedIntervals IntervalEvaluationCollection {
-      get { return (NamedIntervals)this[IntervalEvaluationResultName].Value; }
+    public IntervalCollection IntervalEvaluationCollection {
+      get { return (IntervalCollection)this[IntervalEvaluationResultName].Value; }
       private set { this[IntervalEvaluationResultName].Value = value; }
     }
@@ -127,5 +127,5 @@
       estimationLimitResults.Add(new Result(TestNaNEvaluationsResultName, "", new IntValue()));
       Add(new Result(EstimationLimitsResultsResultName, "Results concerning the estimation limits of symbolic regression solution", estimationLimitResults));
-      Add(new Result(IntervalEvaluationResultName, "Results concerning the derivation of symbolic regression solution", new NamedIntervals()));
+      Add(new Result(IntervalEvaluationResultName, "Results concerning the derivation of symbolic regression solution", new IntervalCollection()));
       RecalculateResults();
     }
@@ -147,5 +147,5 @@
         estimationLimitResults.Add(new Result(TestNaNEvaluationsResultName, "", new IntValue()));
         Add(new Result(EstimationLimitsResultsResultName, "Results concerning the estimation limits of symbolic regression solution", estimationLimitResults));
-        Add(new Result(IntervalEvaluationResultName, "Results concerning the derivation of symbolic regression solution", new NamedIntervals()));
+        Add(new Result(IntervalEvaluationResultName, "Results concerning the derivation of symbolic regression solution", new IntervalCollection()));
         CalculateResults();
       }
@@ -174,6 +174,6 @@
     }
 
-    private static NamedIntervals CalculateModelIntervals(ISymbolicRegressionSolution solution) {
-      var intervalEvaluation = new NamedIntervals();
+    private static IntervalCollection CalculateModelIntervals(ISymbolicRegressionSolution solution) {
+      var intervalEvaluation = new IntervalCollection();
       var interpreter = new IntervalInterpreter();
       var problemData = solution.ProblemData;
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalCollectionView.Designer.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalCollectionView.Designer.cs	(revision 16903)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalCollectionView.Designer.cs	(revision 16904)
@@ -21,5 +21,5 @@
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
-  partial class NamedIntervalsView {
+  partial class IntervalCollectionView {
     /// <summary> 
     /// Required designer variable.
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalCollectionView.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalCollectionView.cs	(revision 16903)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/IntervalCollectionView.cs	(revision 16904)
@@ -29,9 +29,9 @@
 
   [View("NamedIntervals View")]
-  [Content(typeof(NamedIntervals), true)]
-  public sealed partial class NamedIntervalsView : AsynchronousContentView {
+  [Content(typeof(IntervalCollection), true)]
+  public sealed partial class IntervalCollectionView : AsynchronousContentView {
 
-    public new NamedIntervals Content {
-      get => (NamedIntervals)base.Content;
+    public new IntervalCollection Content {
+      get => (IntervalCollection)base.Content;
       set => base.Content = value;
     }
@@ -41,5 +41,5 @@
     }
 
-    public NamedIntervalsView() {
+    public IntervalCollectionView() {
       InitializeComponent();
       dataGridView.AutoGenerateColumns = false;
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs	(revision 16903)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs	(revision 16904)
@@ -28,5 +28,5 @@
   [Item("NamedIntervals", "Represents variables with their interval ranges.")]
   [StorableType("230B4E4B-41E5-4D33-9BC3-E2DAADDCA5AE")]
-  public class NamedIntervals : Item {
+  public class IntervalCollection : Item {
     public static new System.Drawing.Image StaticItemImage {
       get => HeuristicLab.Common.Resources.VSImageLibrary.Object;
@@ -51,9 +51,9 @@
     }
 
-    public NamedIntervals() : base() { }
+    public IntervalCollection() : base() { }
     [StorableConstructor]
-    protected NamedIntervals(StorableConstructorFlag _) : base(_) { }
+    protected IntervalCollection(StorableConstructorFlag _) : base(_) { }
 
-    protected NamedIntervals(NamedIntervals original, Cloner cloner) : base(original, cloner) {
+    protected IntervalCollection(IntervalCollection original, Cloner cloner) : base(original, cloner) {
       foreach (var keyValuePair in original.VariableIntervals) {
         VariableIntervals.Add(keyValuePair.Key, new Interval(keyValuePair.Value.LowerBound, keyValuePair.Value.UpperBound));
@@ -62,5 +62,5 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new NamedIntervals(this, cloner);
+      return new IntervalCollection(this, cloner);
     }
 
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 16903)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 16904)
@@ -93,5 +93,5 @@
       problemData.Parameters.Add(new FixedValueParameter<IntRange>(TestPartitionParameterName, "", (IntRange)new IntRange(0, 0).AsReadOnly()));
       problemData.Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>()));
-      problemData.Parameters.Add(new FixedValueParameter<NamedIntervals>(VariableRangesParameterName, "", new NamedIntervals()));
+      problemData.Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, "", new IntervalCollection()));
       problemData.Parameters.Add(new FixedValueParameter<ProblemDataConstraint>(IntervalConstraintsParameterName, "", new ProblemDataConstraint()));
       emptyProblemData = problemData;
@@ -103,7 +103,7 @@
     }
 
-    public IFixedValueParameter<NamedIntervals> VariableRangesParameter => (IFixedValueParameter<NamedIntervals>)Parameters[VariableRangesParameterName];
-
-    public NamedIntervals VariableRanges {
+    public IFixedValueParameter<IntervalCollection> VariableRangesParameter => (IFixedValueParameter<IntervalCollection>)Parameters[VariableRangesParameterName];
+
+    public IntervalCollection VariableRanges {
       get => VariableRangesParameter.Value;
       set => VariableRanges = value ?? throw new ArgumentNullException("Variable Ranges", "The given variable ranges are null");
@@ -148,12 +148,12 @@
       if (!Parameters.ContainsKey(VariableRangesParameterName)) {
         var variables = InputVariables.Select(x => x.AsReadOnly()).ToList();
-        NamedIntervals namedIntervals = new NamedIntervals();
+        IntervalCollection intervalCollection = new IntervalCollection();
         foreach (var variable in variables) {
           if (!this.Dataset.DoubleVariables.Contains(variable.Value)) continue; // intervals are only possible for double variables
           var variableInterval = Interval.GetInterval(this.Dataset.GetDoubleValues(variable.Value));
-          namedIntervals.VariableIntervals.Add(variable.Value, variableInterval);
+          intervalCollection.VariableIntervals.Add(variable.Value, variableInterval);
         }
 
-        Parameters.Add(new FixedValueParameter<NamedIntervals>(VariableRangesParameterName, namedIntervals));
+        Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, intervalCollection));
       }
       if (!Parameters.ContainsKey(IntervalConstraintsParameterName)) { 
@@ -187,13 +187,13 @@
       var variables = InputVariables.Select(x => x.AsReadOnly()).ToList();
       Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>(variables), variables.Where(x => x.Value == targetVariable).First()));
-      
-      NamedIntervals namedIntervals = new NamedIntervals();
+
+      IntervalCollection intervalCollection = new IntervalCollection();
       foreach (var variable in variables) {
         if (!dataset.DoubleVariables.Contains(variable.Value)) continue; // intervals are only possible for double variables
         var variableInterval = Interval.GetInterval(dataset.GetDoubleValues(variable.Value));
-        namedIntervals.VariableIntervals.Add(variable.Value, variableInterval);
+        intervalCollection.VariableIntervals.Add(variable.Value, variableInterval);
       }
       
-      Parameters.Add(new FixedValueParameter<NamedIntervals>(VariableRangesParameterName, namedIntervals));
+      Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, intervalCollection));
       Parameters.Add(new FixedValueParameter<ProblemDataConstraint>(IntervalConstraintsParameterName, new ProblemDataConstraint(this)));
       RegisterParameterEvents();
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs	(revision 16903)
+++ branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs	(revision 16904)
@@ -28,5 +28,5 @@
     string TargetVariable { get; set; }
 
-    NamedIntervals VariableRanges { get; set; }
+    IntervalCollection VariableRanges { get; set; }
     ProblemDataConstraint IntervalConstraints { get; set; }
 