Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintConstOptEvaluator.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintConstOptEvaluator.cs	(revision 16923)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintConstOptEvaluator.cs	(revision 16924)
@@ -60,5 +60,5 @@
 
       var constraints = problemData.IntervalConstraints.Constraints.Where(x => x.Enabled);
-      var variableRanges = problemData.VariableRanges.getIntervals();
+      var variableRanges = problemData.VariableRanges.GetIntervals();
 
       var r2 = SymbolicRegressionConstantOptimizationEvaluator.OptimizeConstants(interpreter, tree, problemData, problemData.TrainingIndices, applyLinearScaling, 10);
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator.cs	(revision 16923)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator.cs	(revision 16924)
@@ -61,5 +61,5 @@
 
       var constraints = problemData.IntervalConstraints.Constraints.Where(x => x.Enabled);
-      var variableRanges = problemData.VariableRanges.getIntervals();
+      var variableRanges = problemData.VariableRanges.GetIntervals();
       var tree = solution;
 
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraintsParser.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraintsParser.cs	(revision 16923)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalConstraintsParser.cs	(revision 16924)
@@ -59,9 +59,9 @@
               var inclLowerBound = match.Groups[5].Value.Trim() == "[";
               var inclUpperBound = match.Groups[9].Value.Trim() == "]";
-              var isDerivation = false;
+              var isEnabled = true;
               var numberOfDerivation = 0;
               var interval = new Interval(lowerBound, upperBound);
 
-              var constraint = new IntervalConstraint(expression, variable, parsedTarget, numberOfDerivation, interval, inclLowerBound, inclUpperBound, true);
+              var constraint = new IntervalConstraint(expression, variable, parsedTarget, numberOfDerivation, interval, inclLowerBound, inclUpperBound, isEnabled);
 
               yield return constraint;
@@ -110,5 +110,5 @@
               var expression = match.Groups[0].Value;
               var parsedTarget = derivationTarget;
-              var isDerivation = true;
+              var isEnabled = true;
               var inclLowerBound = match.Groups[12].Value.Trim() == "[";
               var inclUpperBound = match.Groups[16].Value.Trim() == "]";
@@ -117,5 +117,5 @@
               var interval = new Interval(lowerBound, upperBound);
 
-              var constraint = new IntervalConstraint(expression, variable, parsedTarget, numberOfDerivation, interval, inclLowerBound, inclUpperBound, true);
+              var constraint = new IntervalConstraint(expression, variable, parsedTarget, numberOfDerivation, interval, inclLowerBound, inclUpperBound, isEnabled);
 
               yield return constraint;