Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression/3.4/ConstrainedNonlinearRegression.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression/3.4/ConstrainedNonlinearRegression.cs	(revision 16940)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression/3.4/ConstrainedNonlinearRegression.cs	(revision 16941)
@@ -250,5 +250,5 @@
       }
       var intervalConstraints = problemData.IntervalConstraints;
-      var dataIntervals = problemData.VariableRanges.VariableIntervals;
+      var dataIntervals = problemData.VariableRanges.GetIntervals();
 
       // convert constants to variables named theta...
@@ -362,10 +362,10 @@
       alglib.minnlcstate state;
       alglib.minnlcreport rep;
-      alglib.optguardreport optGuardRep;
+      //alglib.optguardreport optGuardRep;
       var x0 = thetaValues.ToArray();
 
       alglib.minnlccreate(x0.Length, x0, out state);
       alglib.minnlcsetalgoslp(state);        // SLP is more robust but slower
-      alglib.minnlcsetcond(state, 0, maxIterations);
+      alglib.minnlcsetcond(state, 1E-6, maxIterations);
       var s = Enumerable.Repeat(1d, x0.Length).ToArray();  // scale is set to unit scale
       alglib.minnlcsetscale(state, s);
@@ -374,10 +374,10 @@
       alglib.minnlcsetnlc(state, 0, constraintTrees.Count);
 
-      alglib.minnlcoptguardsmoothness(state);
-      alglib.minnlcoptguardgradient(state, 0.001);
+      // alglib.minnlcoptguardsmoothness(state);
+      // alglib.minnlcoptguardgradient(state, 0.001);
 
       alglib.minnlcoptimize(state, calculate_jacobian, null, null);
       alglib.minnlcresults(state, out double[] xOpt, out rep);
-      alglib.minnlcoptguardresults(state, out optGuardRep);
+      // alglib.minnlcoptguardresults(state, out optGuardRep);
 
       var interpreter = new SymbolicDataAnalysisExpressionTreeLinearInterpreter();
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression/3.4/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression-3.4.csproj
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression/3.4/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression-3.4.csproj	(revision 16940)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression/3.4/HeuristicLab.Algorithms.DataAnalysis.ConstrainedNonlinearRegression-3.4.csproj	(revision 16941)
@@ -48,4 +48,5 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\..\trunk\bin\ALGLIB-3.15.0.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="System" />
@@ -149,4 +150,5 @@
       <Project>{f4539fb6-4708-40c9-be64-0a1390aea197}</Project>
       <Name>HeuristicLab.Random-3.3</Name>
+      <Private>False</Private>
     </ProjectReference>
   </ItemGroup>
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Regression.Symbolic.Extensions/ConstrainedConstantOptimizationEvaluator.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Regression.Symbolic.Extensions/ConstrainedConstantOptimizationEvaluator.cs	(revision 16940)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Regression.Symbolic.Extensions/ConstrainedConstantOptimizationEvaluator.cs	(revision 16941)
@@ -225,5 +225,5 @@
 
       var intervalConstraints = problemData.IntervalConstraints;
-      var dataIntervals = problemData.VariableRanges.VariableIntervals;
+      var dataIntervals = problemData.VariableRanges.GetIntervals();
 
       // convert constants to variables named theta...
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Regression.Symbolic.Extensions/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Extensions.csproj
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Regression.Symbolic.Extensions/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Extensions.csproj	(revision 16940)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Regression.Symbolic.Extensions/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Extensions.csproj	(revision 16941)
@@ -122,4 +122,5 @@
       <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
       <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+      <Private>False</Private>
     </ProjectReference>
   </ItemGroup>