Index: branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs
===================================================================
--- branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs	(revision 16911)
+++ branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs	(revision 16943)
@@ -20,6 +20,9 @@
 #endregion
 
+using HEAL.Attic;
+
 namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
+  [StorableType("F4D6C4AE-C222-4175-9D05-E13707D0EDDB")]
   public enum ProblemType {
     LinearProgramming,
Index: branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs
===================================================================
--- branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs	(revision 16911)
+++ branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs	(revision 16943)
@@ -20,6 +20,9 @@
 #endregion
 
+using HEAL.Attic;
+
 namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
+  [StorableType("BBFFAAAC-F9F6-40A9-BC6E-683257F03E2B")]
   public enum ProtoWriteFormat {
     ProtoText,
Index: branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ResultStatus.cs
===================================================================
--- branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ResultStatus.cs	(revision 16911)
+++ branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/ResultStatus.cs	(revision 16943)
@@ -1,4 +1,28 @@
-﻿namespace HeuristicLab.ExactOptimization.LinearProgramming {
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
 
+using HEAL.Attic;
+
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
+
+  [StorableType("73192CE9-6D6B-4631-95BE-C15B8B5F9FE6")]
   public enum ResultStatus {
     Optimal,        // optimal.
Index: branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs
===================================================================
--- branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs	(revision 16911)
+++ branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs	(revision 16943)
@@ -20,8 +20,9 @@
 #endregion
 
-using Google.OrTools.LinearSolver;
+using HEAL.Attic;
 
 namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
+  [StorableType("D6947706-E560-4D5C-8022-C6F1F20DCD8B")]
   public enum SolverResponseStatus {
     Optimal = 0,
Index: branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IExternalLinearSolver.cs
===================================================================
--- branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IExternalLinearSolver.cs	(revision 16911)
+++ branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IExternalLinearSolver.cs	(revision 16943)
@@ -20,6 +20,9 @@
 #endregion
 
+using HEAL.Attic;
+
 namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
+  [StorableType("5892CCCB-7D74-4748-B221-DA12C90B682B")]
   public interface IExternalLinearSolver : ILinearSolver {
     string LibraryName { get; set; }
Index: branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalLinearSolver.cs
===================================================================
--- branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalLinearSolver.cs	(revision 16911)
+++ branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalLinearSolver.cs	(revision 16943)
@@ -21,7 +21,9 @@
 
 using System;
+using HEAL.Attic;
 
 namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
+  [StorableType("D9B54575-1F8A-4A09-9C62-7492C06535B0")]
   public interface IIncrementalLinearSolver : ILinearSolver {
     TimeSpan QualityUpdateInterval { get; set; }
Index: branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ILinearSolver.cs
===================================================================
--- branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ILinearSolver.cs	(revision 16911)
+++ branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ILinearSolver.cs	(revision 16943)
@@ -22,4 +22,5 @@
 using System;
 using System.Threading;
+using HEAL.Attic;
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
@@ -27,4 +28,5 @@
 namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
+  [StorableType("D647D4F0-A0F5-4091-8F12-54E59CEF12E4")]
   public interface ILinearSolver : IParameterizedNamedItem {
     double DualTolerance { get; set; }
Index: branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Problems/ILinearProblemDefinition.cs
===================================================================
--- branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Problems/ILinearProblemDefinition.cs	(revision 16911)
+++ branches/2994-AutoDiffForIntervals/HeuristicLab.ExactOptimization/3.3/LinearProgramming/Problems/ILinearProblemDefinition.cs	(revision 16943)
@@ -21,4 +21,5 @@
 
 using Google.OrTools.LinearSolver;
+using HEAL.Attic;
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
@@ -26,4 +27,5 @@
 namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
+  [StorableType("4C6CEA85-0197-4A92-A969-C2F964F56388")]
   public interface ILinearProblemDefinition : IItem {
 